# Create a new worker

POST https://api.letsdeel.com/rest/v2/worker
Content-Type: application/json

Creates a new worker account with the specified profile type

Reference: https://developer.deel.com/api/reference/endpoints/workers/create-worker

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /worker:
    post:
      operationId: create-worker
      summary: Create a new worker
      description: Creates a new worker account with the specified profile type
      tags:
        - subpackage_workers
      parameters:
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Worker created successfully
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Workers_createWorker_Response_201'
        '400':
          description: Validation error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateWorkerRequestBadRequestError'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CreateWorkerRequestInternalServerError'
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                data:
                  $ref: >-
                    #/components/schemas/WorkerPostRequestBodyContentApplicationJsonSchemaData
              required:
                - data
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    WorkerPostRequestBodyContentApplicationJsonSchemaDataCompanyType:
      type: string
      enum:
        - COMPANY
        - INDIVIDUAL
      description: Type of company registration
      title: WorkerPostRequestBodyContentApplicationJsonSchemaDataCompanyType
    WorkerPostRequestBodyContentApplicationJsonSchemaDataCompanyPersonal:
      type: object
      properties:
        zip:
          type: number
          format: double
          description: Zip/Postal code
        city:
          type: string
          description: City
        phone:
          type: number
          format: double
          description: Phone number
        street:
          type: string
          description: Street address
        citizen:
          type: string
          description: Citizenship country code
        country:
          type: string
          description: Country code
        id_type:
          type: string
          description: Type of identification
        province:
          type:
            - string
            - 'null'
          description: Province/State
        timezone:
          type: string
          description: Personal timezone
        personal_id:
          type: number
          format: double
          description: Personal identification number
        legal_status:
          type: string
          description: Legal status (required only when type is INDIVIDUAL)
        tax_residence:
          type: string
          description: Tax residence country code
        entity_tax_residence:
          type: string
          description: Entity tax residence (only applicable for company type)
      required:
        - zip
        - city
        - phone
        - street
        - citizen
        - personal_id
      title: WorkerPostRequestBodyContentApplicationJsonSchemaDataCompanyPersonal
    WorkerPostRequestBodyContentApplicationJsonSchemaDataCompany:
      type: object
      properties:
        type:
          $ref: >-
            #/components/schemas/WorkerPostRequestBodyContentApplicationJsonSchemaDataCompanyType
          description: Type of company registration
        personal:
          $ref: >-
            #/components/schemas/WorkerPostRequestBodyContentApplicationJsonSchemaDataCompanyPersonal
      required:
        - type
        - personal
      title: WorkerPostRequestBodyContentApplicationJsonSchemaDataCompany
    WorkerPostRequestBodyContentApplicationJsonSchemaDataProfileType:
      type: string
      enum:
        - CONTRACTOR
        - EOR
      description: Type of worker profile
      title: WorkerPostRequestBodyContentApplicationJsonSchemaDataProfileType
    WorkerPostRequestBodyContentApplicationJsonSchemaData:
      type: object
      properties:
        email:
          type: string
          format: email
          description: Worker's email address
        company:
          $ref: >-
            #/components/schemas/WorkerPostRequestBodyContentApplicationJsonSchemaDataCompany
        timezone:
          type: string
          description: Worker's timezone
        last_name:
          type: string
          description: Worker's last name
        first_name:
          type: string
          description: Worker's first name
        contract_id:
          type: string
          description: Associated contract ID
        middle_name:
          type:
            - string
            - 'null'
          description: Worker's middle name
        profile_type:
          $ref: >-
            #/components/schemas/WorkerPostRequestBodyContentApplicationJsonSchemaDataProfileType
          description: Type of worker profile
        preferred_name:
          type:
            - string
            - 'null'
          description: Worker's preferred name
        preferred_lastName:
          type:
            - string
            - 'null'
          description: Worker's preferred last name
        preferred_firstname:
          type:
            - string
            - 'null'
          description: Worker's preferred first name
      required:
        - email
        - company
        - timezone
        - last_name
        - first_name
        - contract_id
        - profile_type
      title: WorkerPostRequestBodyContentApplicationJsonSchemaData
    WorkerPostResponsesContentApplicationJsonSchemaData:
      type: object
      properties:
        user_id:
          type: string
          description: Created user ID
        profile_id:
          type: string
          description: Created profile ID
        contract_id:
          type: string
          description: Associated contract ID
      required:
        - user_id
        - profile_id
        - contract_id
      title: WorkerPostResponsesContentApplicationJsonSchemaData
    Workers_createWorker_Response_201:
      type: object
      properties:
        data:
          $ref: >-
            #/components/schemas/WorkerPostResponsesContentApplicationJsonSchemaData
      required:
        - data
      title: Workers_createWorker_Response_201
    CreateWorkerRequestBadRequestError:
      type: object
      properties:
        error:
          type: string
      title: CreateWorkerRequestBadRequestError
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
    CreateWorkerRequestInternalServerError:
      type: object
      properties:
        error:
          type: string
      title: CreateWorkerRequestInternalServerError
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/worker"

payload = { "data": {
        "email": "john.doe@deel.com",
        "company": {
            "type": "INDIVIDUAL",
            "personal": {
                "city": "Toronto",
                "phone": 14165550123,
                "street": "123 Front Street West",
                "citizen": "CA",
                "personal_id": 123456789
            }
        },
        "timezone": "America/Toronto",
        "last_name": "Doe",
        "first_name": "John",
        "contract_id": "m4xdqx6",
        "profile_type": "CONTRACTOR"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/worker';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"email":"john.doe@deel.com","company":{"type":"INDIVIDUAL","personal":{"city":"Toronto","phone":14165550123,"street":"123 Front Street West","citizen":"CA","personal_id":123456789}},"timezone":"America/Toronto","last_name":"Doe","first_name":"John","contract_id":"m4xdqx6","profile_type":"CONTRACTOR"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/worker"

	payload := strings.NewReader("{\n  \"data\": {\n    \"email\": \"john.doe@deel.com\",\n    \"company\": {\n      \"type\": \"INDIVIDUAL\",\n      \"personal\": {\n        \"city\": \"Toronto\",\n        \"phone\": 14165550123,\n        \"street\": \"123 Front Street West\",\n        \"citizen\": \"CA\",\n        \"personal_id\": 123456789\n      }\n    },\n    \"timezone\": \"America/Toronto\",\n    \"last_name\": \"Doe\",\n    \"first_name\": \"John\",\n    \"contract_id\": \"m4xdqx6\",\n    \"profile_type\": \"CONTRACTOR\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/worker")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"email\": \"john.doe@deel.com\",\n    \"company\": {\n      \"type\": \"INDIVIDUAL\",\n      \"personal\": {\n        \"city\": \"Toronto\",\n        \"phone\": 14165550123,\n        \"street\": \"123 Front Street West\",\n        \"citizen\": \"CA\",\n        \"personal_id\": 123456789\n      }\n    },\n    \"timezone\": \"America/Toronto\",\n    \"last_name\": \"Doe\",\n    \"first_name\": \"John\",\n    \"contract_id\": \"m4xdqx6\",\n    \"profile_type\": \"CONTRACTOR\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/v2/worker")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"email\": \"john.doe@deel.com\",\n    \"company\": {\n      \"type\": \"INDIVIDUAL\",\n      \"personal\": {\n        \"city\": \"Toronto\",\n        \"phone\": 14165550123,\n        \"street\": \"123 Front Street West\",\n        \"citizen\": \"CA\",\n        \"personal_id\": 123456789\n      }\n    },\n    \"timezone\": \"America/Toronto\",\n    \"last_name\": \"Doe\",\n    \"first_name\": \"John\",\n    \"contract_id\": \"m4xdqx6\",\n    \"profile_type\": \"CONTRACTOR\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/v2/worker', [
  'body' => '{
  "data": {
    "email": "john.doe@deel.com",
    "company": {
      "type": "INDIVIDUAL",
      "personal": {
        "city": "Toronto",
        "phone": 14165550123,
        "street": "123 Front Street West",
        "citizen": "CA",
        "personal_id": 123456789
      }
    },
    "timezone": "America/Toronto",
    "last_name": "Doe",
    "first_name": "John",
    "contract_id": "m4xdqx6",
    "profile_type": "CONTRACTOR"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/worker");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"email\": \"john.doe@deel.com\",\n    \"company\": {\n      \"type\": \"INDIVIDUAL\",\n      \"personal\": {\n        \"city\": \"Toronto\",\n        \"phone\": 14165550123,\n        \"street\": \"123 Front Street West\",\n        \"citizen\": \"CA\",\n        \"personal_id\": 123456789\n      }\n    },\n    \"timezone\": \"America/Toronto\",\n    \"last_name\": \"Doe\",\n    \"first_name\": \"John\",\n    \"contract_id\": \"m4xdqx6\",\n    \"profile_type\": \"CONTRACTOR\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "email": "john.doe@deel.com",
    "company": [
      "type": "INDIVIDUAL",
      "personal": [
        "city": "Toronto",
        "phone": 14165550123,
        "street": "123 Front Street West",
        "citizen": "CA",
        "personal_id": 123456789
      ]
    ],
    "timezone": "America/Toronto",
    "last_name": "Doe",
    "first_name": "John",
    "contract_id": "m4xdqx6",
    "profile_type": "CONTRACTOR"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/worker")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```